//+------------------------------------------------------------------+
//|                                       Heiken Ashi zone trade.mq4 |
//|                                                                  |
//| kept the name even though it has                                 |
//|  nothing to do with heiken ashi                                  |
//+------------------------------------------------------------------+
#property copyright "http://www.forex-tsd.com"
#property link      "http://www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  RoyalBlue
#property indicator_color2  Red
#property indicator_color3  Silver
#property indicator_color4  DimGray
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  3
#property indicator_width4  3
#property indicator_minimum 0
#property indicator_maximum 0

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double trend[];

int    timeFrame;
bool   returnBars;
string indicatorFileName;

//+------------------------------------------------------------------+
//|                                                                  |
//|------------------------------------------------------------------|
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0, ExtMapBuffer1); SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexEmptyValue(0,0);
   SetIndexBuffer(1, ExtMapBuffer2); SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexEmptyValue(1,0);
   SetIndexBuffer(2, ExtMapBuffer3); SetIndexStyle(2,DRAW_HISTOGRAM); SetIndexEmptyValue(2,0);
   SetIndexBuffer(3, ExtMapBuffer4); SetIndexStyle(3,DRAW_HISTOGRAM); SetIndexEmptyValue(3,0);
   SetIndexBuffer(4, trend);
   
      //
      //
      //
      //
      //
      
      returnBars        = (TimeFrame=="returnBars");   if (returnBars)  return(0);
      indicatorFileName = WindowExpertName();
      timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
   IndicatorShortName(timeFrameToString(timeFrame)+" heiken ashi zone trade");      
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            limit = MathMin(Bars-counted_bars,Bars-1);
            if (returnBars)  { ExtMapBuffer1[0] = limit+1; return(0); }
            if (timeFrame > Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
         
          
   //
   //
   //
   //
   //
   
   for(i=limit; i >= 0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      double acC = iAC(NULL,timeFrame,y); double acP = iAC(NULL,timeFrame,y+1); int acD = 0; if (acC>acP) acD=1; if (acC<acP) acD=2;
      double aoC = iAO(NULL,timeFrame,y); double aoP = iAO(NULL,timeFrame,y+1); int aoD = 0; if (aoC>aoP) aoD=1; if (aoC<aoP) aoD=2;
        
      //
      //
      //
      //
      //
      
      ExtMapBuffer1[i] = 0.0;
      ExtMapBuffer2[i] = 0.0;
      ExtMapBuffer3[i] = 0.0;
      ExtMapBuffer4[i] = 0.0;
      trend[i]         = trend[i+1];
   
         if(acD==1 && aoD==1) { trend[i] = 1; ExtMapBuffer1[i]=1; }
         if(acD==2 && aoD==2) { trend[i] = 2; ExtMapBuffer2[i]=1; }
         if(acD==1 && aoD==2) { trend[i] = 3; ExtMapBuffer3[i]=1; }
         if(acD==2 && aoD==1) { trend[i] = 4; ExtMapBuffer4[i]=1; }
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));

      //
      //
      //
      //
      //
      
      if (trend[whichBar] != trend[whichBar+1])
         switch(trend[whichBar])
         {
            case 1 :  doAlert("up");      break;
            case 2 :  doAlert("down");    break;
            case 3 :  doAlert("neutral"); break;
            case 4 :  doAlert("neutral"); break;
         }               
   }

   //
   //
   //
   //
          
   return(0);
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," heiken ashi zone trade trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," heiken ashi zone trade "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}